/*                      ************ Task file ******************

Grammar:
	1. Variable. Only support "int". Can be "static" or not.
	2. Operators. "+", "-", "*", "/", "+=", "-=", "*=", "/=", "++", "--", Negative, "=".
	3. Logic. ">", "<", "==", ">=", "<=", "!=", "&&", "||", "!".
	4. Select. "if", "else", "else if", "?:".
	5. return

*/

int TaskEntry()
{	
	//if( !Recording() )
	//	return TRIAL_NONE;

	static int dITI = GetTime();
	static int dITI2 = GetTime();
	static int dTARGET_ON = GetTime();
	static int dTARGET_OFF = GetTime();
	static int dFOREP = GetTime();
	static int dITIDur = Rand(GetBehavParam("MinITIDur"), GetBehavParam("MaxITIDur"));
	static int dITI2Dur = Rand(GetBehavParam("MinITI2Dur"), GetBehavParam("MaxITI2Dur"));
	static int dFixDur = Rand(GetBehavParam("MinFixDur"), GetBehavParam("MaxFixDur"));

    static int dEYE_ON_TARGET = GetTime();
    static int nEye_On_Target = FALSE;

	if( nTaskState == ITI )
	{
		// extend ITI if button down
		
		// Turn on target when ITI expired.
		if( nCurrentTime >= dITI + dITIDur )
		{
			// draw iscan window and object
			int upd = GetBehavParam("UnitsPerDeg");
			int TPosH = GetGraphParam("TPOSH") * 60 / upd;
			int TPosV = GetGraphParam("TPOSV") * 60 / upd;
			int FPWinRad = GetBehavParam("FPWinRad");
			FPCircle(TPosH, TPosV, FPWinRad, 9);

			TurnOnTarget();
			nEye_On_Target = FALSE;
			dTARGET_ON = GetTime();
			nTaskState = TARGET_ON;
			dITIDur = Rand(GetBehavParam("MinITIDur"), GetBehavParam("MaxITIDur"));
			dFixDur = Rand(GetBehavParam("MinFixDur"), GetBehavParam("MaxFixDur"));
		}
	} else if( nTaskState == ITI2 ) {
		if( nCurrentTime >= dITI2 + dITI2Dur )
		{
			nTaskState = ITI;
			dITI = nCurrentTime;
			dITI2Dur = Rand(GetBehavParam("MinITI2Dur"), GetBehavParam("MaxITI2Dur"));
		}
	} else if( nTaskState == TARGET_ON ) {
	    if(nEye_On_Target) {
	        if(nCurrentTime > dEYE_ON_TARGET + GetBehavParam("PreFixDur")) {
	            nTaskState = FOREP;
	            TurnOnFig();
	            dFOREP = nCurrentTime;
	        } else if(!OnFP()) {
    			TurnOffTarget();
	            nTaskState = ITI;
	            dITI = nCurrentTime;
	            return TRIAL_FAIL;
	        }
	    } else {
    		if(OnFP()) {
    		    nEye_On_Target = TRUE;
    		    dEYE_ON_TARGET = nCurrentTime;
    		} else if(nCurrentTime > dTARGET_ON + GetBehavParam("TargetOnDur")) {
    			TurnOffTarget();
    			nTaskState = ITI;
    			dITI = nCurrentTime;
    			return TRIAL_FAIL;
    		}
        }
	} else if( nTaskState == FOREP ) {
		if(nCurrentTime >= dFOREP + dFixDur) {
			TurnOffTarget();
			TurnOffFig();
			DoHitAct();
			SaveResponse(TRIAL_HIT, nCurrentTime - dFOREP - dFixDur, 1, 1, dFixDur );
			nTaskState = ITI;
			dITI = nCurrentTime;
			return TRIAL_END;
		} else if(!OnFP()) {
			TurnOffTarget();
			TurnOffFig();
			DoEarlyAct();
			SaveResponse(TRIAL_EARLY, nCurrentTime - dFOREP - dFixDur, 1, 3, dFixDur );
			nTaskState = ITI2;
			dITI2 = nCurrentTime;
			if(GetBehavParam("AnalysisTime") + 20 > nCurrentTime - dFOREP)
				return TRIAL_REPEAT;
			else
				return TRIAL_END;
		}
	}
	return TRIAL_CONTINUE;
}